# JSDoc: Source: utils/hashUtils.js

# Source: utils/hashUtils.js

    /*Canopy - The next generation of stoner streaming software
    Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

    //Config
    const config = require('../../config.json');

    //Node Imports
    const crypto = require('node:crypto');

    //NPM Imports
    const bcrypt = require('bcrypt');

    /**
     * Sitewide function for hashing passwords
     * @param {String} pass - Password to hash
     * @returns {String} Hashed/Salted password
     */
    module.exports.hashPassword = function(pass){
        const salt = bcrypt.genSaltSync();
        return bcrypt.hashSync(pass, salt);
    }

    /**
     * Sitewide password for authenticating/comparing passwords agianst hashes
     * @param {String} pass - Plaintext Password
     * @param {String} hash - Salty Hash
     * @returns {Boolean} True if authentication success
     */
    module.exports.comparePassword = function(pass, hash){
        return bcrypt.compareSync(pass, hash);
    }

    /**
     * Site-wide IP hashing/salting function
     *
     * Provides a basic level of privacy by only logging salted hashes of IP's
     * @param {String} ip - IP to hash
     * @returns {String} Hashed/Salted IP Adress
     */
    module.exports.hashIP = function(ip){
        //Create hash object
        const hashObj = crypto.createHash('md5');

        //add IP and salt to the hash
        hashObj.update(`${ip}${config.ipSecret}`);

        //return the IP hash as a string
        return hashObj.digest('hex');
    }